package name.panitz.ki
class InformedSlide(I:Int) extends DepthSlide(I) 
                     with InformedSearch[Direction.Value]{


  def estimatedGoalDistance():Int={
    var result=0;
    for (val i<-Iterator.range(0,SIZE);val j<-Iterator.range(0,SIZE)){
      val v=field(i)(j)
      if (v>0){
        val shouldY=v/SIZE
        val shouldX=v%SIZE
        result=result+Math.abs(shouldY-i)+Math.abs(shouldX-j)
      }
    }
    result
  }

  def pathDistance(xs:List[Direction.Value]):Int=xs.length

  def this(that:SlidePuzzle)={this(that.SIZE);copyFromThat(that)}
  override def move(m:Direction.Value):InformedSlide={
    val res=new InformedSlide(this)
    res.move(m,res)
    res
  }
}

