package name.panitz.eliza;
class Eliza {

  import Util.{_}
  val data=new Data()
  var prev = ""

  def eval(s1:String):String={
    val s=stripPunctuation(s1.trim()).toUpperCase()
    var result = ""
    if (s==prev) {
      result = data.repeatMsgs.x.head
      rotate(data.repeatMsgs)
    }else result = ans(words(s))
    prev = s
    result
  }

  def ans(qs:List[String] )={
    val responses =
     for (val Pair(key,resp)<-data.responses
         ;val q<-tails(qs)
         ;isPrefix(key,q) )
       yield Pair(resp,makeResponse(resp.x.head
                                   ,conjug(resp.x,q.drop(key.length))))
    rotate(responses.head._1)
    responses.head._2
  }

  def conjug(q:List[String],xs:List[String])
   =unwords(for (val y<-if(xs.isEmpty) q else xs) yield conj(y))

  def conj(s:String)
   =try {data.CONJUGATES(s)}catch {case e:Throwable => s}

  def makeResponse( cs:String, us:String)=
    if (cs.charAt(0)=='?') cs.substring(1)+" "+us.toLowerCase()+"?"
    else if(cs.charAt(0)=='.')cs.substring(1)+" "+us.toLowerCase+"."
    else cs
}

