package name.panitz.eliza;
object Util{
  def rotate[a](xs:Box[List[a]])
   =xs.x=(xs.x.tail ::: (List(xs.x.head)))

  def isPrefix[a](xs:List[a],ys:List[a]):Boolean
   = if (xs.isEmpty) true 
     else if (ys.isEmpty) false
     else xs.head==ys.head && isPrefix(xs.tail,ys.tail)

  def unwords[a](xs:List[a]):String
   = if (xs.isEmpty) ""
     else if (xs.tail.isEmpty) xs.head.toString()
     else xs.head.toString()+" "+unwords(xs.tail)

  def tails[a](xs:List[a]):List[List[a]]
   =if (xs.isEmpty) List(xs) else tails(xs.tail).::(xs)

  def  words (s:String):List[String]={
    var s1 = s.trim()
    var i = s1.indexOf(' ')
    if (i<0) List(s1)
    else words(s1.substring(i)) .:: (s1.substring(0,i))
  } 
 
 def stripPunctuation(s:String): String={
    var result="";
    for (val i<-Iterator.range(0,s.length())){
      if (PUNCTUATIONS.indexOf(s.charAt(i))<0){
        result=result+s.charAt(i);
      }else{}      
    }
    result
  }
  val PUNCTUATIONS =".,;:!"

  def trace[a](s :String,x:a):a={Console.print(s+": ");Console.println(x);x}
}


